stages:
  - install_dependencies
  - build
  - deploy

image: cirrusci/flutter

cache: &global_cache
  key: $CI_COMMIT_REF_SLUG
  paths:
    - .pub-cache/
  policy: pull-push

variables:
  PUB_CACHE: "$CI_PROJECT_DIR/.pub-cache"

# Get dependencies for all jobs
get_dependencies:
  stage: install_dependencies
  only:
    - main
    - tags
  cache:
    # inherit all global cache settings
    <<: *global_cache
  script:
    - flutter pub get

flutter_build_android:
  stage: build
  only:
    - main
    - tags
  needs:
    - job: get_dependencies
  cache:
    <<: *global_cache
    policy: pull
  before_script:
    - flutter pub get
    - echo "$KEY_PROPERTIES" | base64 -d > android/key.properties
    - echo "$KEYSTORE" | base64 -d > keystore.jks
  script:
    - mkdir -p bin/android
    # Build universal apk
    - flutter build apk
    - mv build/app/outputs/apk/release/app-release.apk bin/android/
    # Build apk split per architecture
    - flutter build apk --split-per-abi
    - mv build/app/outputs/apk/release/*.apk bin/android/
    # Build appbundle
    - flutter build appbundle
    - mv build/app/outputs/bundle/release/app-release.aab bin/android/
  artifacts:
    paths: ["bin/android*"]
    expire_in: 1 month

firebase_deploy:
  stage: deploy
  needs:
    - job: flutter_build_android
      artifacts: true
  only:
    - tags
  except:
    - branches
  image: python:latest
  variables:
    PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"
  cache:
    key: $CI_COMMIT_REF_SLUG-deploy
    paths:
      - .cache/pip
      - venv/
  before_script:
    - pip install virtualenv
    - virtualenv venv
    - source venv/bin/activate
  script:
    - ./.script/release_test.sh -f "${CI_PROJECT_DIR}/pubspec.yaml" -t $CI_COMMIT_TAG
    - pip install firebase-admin
    - python .script/upload.py "$SERVICE_KEY" "$CI_COMMIT_TAG" bin
